!function(root, factory) {
    "object" == typeof exports && "object" == typeof module ? module.exports = factory() : "function" == typeof define && define.amd ? define([], factory) : "object" == typeof exports ? exports.akLozenge = factory() : root.akLozenge = factory();
}(this, function() {
    /******/
    return function(modules) {
        /******/
        /******/
        // The require function
        /******/
        function __webpack_require__(moduleId) {
            /******/
            /******/
            // Check if module is in cache
            /******/
            if (installedModules[moduleId]) /******/
            return installedModules[moduleId].exports;
            /******/
            /******/
            // Create a new module (and put it into the cache)
            /******/
            var module = installedModules[moduleId] = {
                /******/
                exports: {},
                /******/
                id: moduleId,
                /******/
                loaded: !1
            };
            /******/
            /******/
            // Return the exports of the module
            /******/
            /******/
            /******/
            // Execute the module function
            /******/
            /******/
            /******/
            // Flag the module as loaded
            /******/
            return modules[moduleId].call(module.exports, module, module.exports, __webpack_require__), 
            module.loaded = !0, module.exports;
        }
        // webpackBootstrap
        /******/
        // The module cache
        /******/
        var installedModules = {};
        /******/
        /******/
        // Load entry module and return exports
        /******/
        /******/
        /******/
        /******/
        // expose the modules object (__webpack_modules__)
        /******/
        /******/
        /******/
        // expose the module cache
        /******/
        /******/
        /******/
        // __webpack_public_path__
        /******/
        return __webpack_require__.m = modules, __webpack_require__.c = installedModules, 
        __webpack_require__.p = "", __webpack_require__(0);
    }([ /* 0 */
    /***/
    function(module, exports, __webpack_require__) {
        "use strict";
        function _interopRequireDefault(obj) {
            return obj && obj.__esModule ? obj : {
                "default": obj
            };
        }
        Object.defineProperty(exports, "__esModule", {
            value: !0
        });
        var _hasOwn = Object.prototype.hasOwnProperty, _forOwn = function(object, iterator) {
            for (var prop in object) _hasOwn.call(object, prop) && iterator(object[prop], prop);
        }, _renderArbitrary = function _renderArbitrary(child) {
            var type = typeof child;
            "number" === type || "string" === type || "object" === type && child instanceof String ? _skatejs.vdom.text(child) : "function" === type && child.__jsxDOMWrapper ? child() : Array.isArray(child) ? child.forEach(_renderArbitrary) : "object" === type && "[object Object]" === String(child) && _forOwn(child, _renderArbitrary);
        };
        __webpack_require__(3);
        var _shadow = __webpack_require__(7), _shadow2 = _interopRequireDefault(_shadow), _skatejs = __webpack_require__(8), _classnames = __webpack_require__(10), _classnames2 = _interopRequireDefault(_classnames), _akutilCommon = __webpack_require__(11), APPEARANCE_ENUM = {
            values: [ "default", "success", "removed", "inprogress", "new", "moved" ],
            missingDefault: "default",
            invalidDefault: "default"
        }, definition = {
            render: function(elem) {
                var classes = (0, _classnames2["default"])([ _shadow2["default"].locals.lozenge, _shadow2["default"].locals[elem.appearance] ]);
                return _skatejs.vdom.elementOpen("span", null, null, "class", classes, "bold", elem.bold), 
                _skatejs.vdom.elementOpen("style"), _renderArbitrary(_shadow2["default"].toString()), 
                _skatejs.vdom.elementClose("style"), _skatejs.vdom.elementOpen("span", null, null, "className", _shadow2["default"].locals.content), 
                _skatejs.vdom.elementOpen("slot"), _skatejs.vdom.elementClose("slot"), _skatejs.vdom.elementClose("span"), 
                _skatejs.vdom.elementClose("span");
            },
            props: {
                /**
	     * @description Affects the visual style of the badge.
	     * Allowed values are: 'default', 'success', 'removed', 'inprogress', 'new', 'moved'.
	     * @memberof AkLozenge
	     * @instance
	     * @type {string}
	     * @default default
	     */
                appearance: (0, _akutilCommon.enumeration)(APPEARANCE_ENUM)({
                    attribute: !0
                }),
                /**
	     * @description Toggles the bolder appearance.
	     * @memberof AkLozenge
	     * @instance
	     * @type {boolean}
	     * @default false
	     */
                bold: _skatejs.prop["boolean"]({
                    attribute: !0,
                    "default": !1
                })
            }
        };
        exports["default"] = (0, _skatejs.define)("ak-lozenge", definition);
    }, /* 1 */
    , /* 2 */
    , /* 3 */
    /***/
    function(module, exports, __webpack_require__) {
        // style-loader: Adds some css to the DOM by adding a <style> tag
        // load the styles
        var content = __webpack_require__(4);
        "string" == typeof content && (content = [ [ module.id, content, "" ] ]);
        // add the styles to the DOM
        __webpack_require__(6)(content, {});
        content.locals && (module.exports = content.locals);
    }, /* 4 */
    /***/
    function(module, exports, __webpack_require__) {
        exports = module.exports = __webpack_require__(5)(), // imports
        // module
        exports.push([ module.id, ".k86cZGnwHuz-nnSTA8MdF,ak-lozenge{display:-webkit-inline-box;display:inline-flex}.k86cZGnwHuz-nnSTA8MdF:not([defined]),ak-lozenge:not([defined]){display:none}.k86cZGnwHuz-nnSTA8MdF>_shadow_root_,ak-lozenge>_shadow_root_{display:-webkit-inline-box;display:inline-flex}", "" ]), 
        // exports
        exports.locals = {
            "ak-lozenge": "k86cZGnwHuz-nnSTA8MdF",
            akLozenge: "k86cZGnwHuz-nnSTA8MdF"
        };
    }, /* 5 */
    /***/
    function(module, exports) {
        /*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
        // css base code, injected by the css-loader
        module.exports = function() {
            var list = [];
            // return the list of modules as css string
            // import a list of modules into the list
            return list.toString = function() {
                for (var result = [], i = 0; i < this.length; i++) {
                    var item = this[i];
                    item[2] ? result.push("@media " + item[2] + "{" + item[1] + "}") : result.push(item[1]);
                }
                return result.join("");
            }, list.i = function(modules, mediaQuery) {
                "string" == typeof modules && (modules = [ [ null, modules, "" ] ]);
                for (var alreadyImportedModules = {}, i = 0; i < this.length; i++) {
                    var id = this[i][0];
                    "number" == typeof id && (alreadyImportedModules[id] = !0);
                }
                for (i = 0; i < modules.length; i++) {
                    var item = modules[i];
                    // skip already imported module
                    // this implementation is not 100% perfect for weird media query combinations
                    //  when a module is imported multiple times with different media queries.
                    //  I hope this will never occur (Hey this way we have smaller bundles)
                    "number" == typeof item[0] && alreadyImportedModules[item[0]] || (mediaQuery && !item[2] ? item[2] = mediaQuery : mediaQuery && (item[2] = "(" + item[2] + ") and (" + mediaQuery + ")"), 
                    list.push(item));
                }
            }, list;
        };
    }, /* 6 */
    /***/
    function(module, exports, __webpack_require__) {
        function addStylesToDom(styles, options) {
            for (var i = 0; i < styles.length; i++) {
                var item = styles[i], domStyle = stylesInDom[item.id];
                if (domStyle) {
                    domStyle.refs++;
                    for (var j = 0; j < domStyle.parts.length; j++) domStyle.parts[j](item.parts[j]);
                    for (;j < item.parts.length; j++) domStyle.parts.push(addStyle(item.parts[j], options));
                } else {
                    for (var parts = [], j = 0; j < item.parts.length; j++) parts.push(addStyle(item.parts[j], options));
                    stylesInDom[item.id] = {
                        id: item.id,
                        refs: 1,
                        parts: parts
                    };
                }
            }
        }
        function listToStyles(list) {
            for (var styles = [], newStyles = {}, i = 0; i < list.length; i++) {
                var item = list[i], id = item[0], css = item[1], media = item[2], sourceMap = item[3], part = {
                    css: css,
                    media: media,
                    sourceMap: sourceMap
                };
                newStyles[id] ? newStyles[id].parts.push(part) : styles.push(newStyles[id] = {
                    id: id,
                    parts: [ part ]
                });
            }
            return styles;
        }
        function insertStyleElement(options, styleElement) {
            var head = getHeadElement(), lastStyleElementInsertedAtTop = styleElementsInsertedAtTop[styleElementsInsertedAtTop.length - 1];
            if ("top" === options.insertAt) lastStyleElementInsertedAtTop ? lastStyleElementInsertedAtTop.nextSibling ? head.insertBefore(styleElement, lastStyleElementInsertedAtTop.nextSibling) : head.appendChild(styleElement) : head.insertBefore(styleElement, head.firstChild), 
            styleElementsInsertedAtTop.push(styleElement); else {
                if ("bottom" !== options.insertAt) throw new Error("Invalid value for parameter 'insertAt'. Must be 'top' or 'bottom'.");
                head.appendChild(styleElement);
            }
        }
        function removeStyleElement(styleElement) {
            styleElement.parentNode.removeChild(styleElement);
            var idx = styleElementsInsertedAtTop.indexOf(styleElement);
            idx >= 0 && styleElementsInsertedAtTop.splice(idx, 1);
        }
        function createStyleElement(options) {
            var styleElement = document.createElement("style");
            return styleElement.type = "text/css", insertStyleElement(options, styleElement), 
            styleElement;
        }
        function createLinkElement(options) {
            var linkElement = document.createElement("link");
            return linkElement.rel = "stylesheet", insertStyleElement(options, linkElement), 
            linkElement;
        }
        function addStyle(obj, options) {
            var styleElement, update, remove;
            if (options.singleton) {
                var styleIndex = singletonCounter++;
                styleElement = singletonElement || (singletonElement = createStyleElement(options)), 
                update = applyToSingletonTag.bind(null, styleElement, styleIndex, !1), remove = applyToSingletonTag.bind(null, styleElement, styleIndex, !0);
            } else obj.sourceMap && "function" == typeof URL && "function" == typeof URL.createObjectURL && "function" == typeof URL.revokeObjectURL && "function" == typeof Blob && "function" == typeof btoa ? (styleElement = createLinkElement(options), 
            update = updateLink.bind(null, styleElement), remove = function() {
                removeStyleElement(styleElement), styleElement.href && URL.revokeObjectURL(styleElement.href);
            }) : (styleElement = createStyleElement(options), update = applyToTag.bind(null, styleElement), 
            remove = function() {
                removeStyleElement(styleElement);
            });
            return update(obj), function(newObj) {
                if (newObj) {
                    if (newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap) return;
                    update(obj = newObj);
                } else remove();
            };
        }
        function applyToSingletonTag(styleElement, index, remove, obj) {
            var css = remove ? "" : obj.css;
            if (styleElement.styleSheet) styleElement.styleSheet.cssText = replaceText(index, css); else {
                var cssNode = document.createTextNode(css), childNodes = styleElement.childNodes;
                childNodes[index] && styleElement.removeChild(childNodes[index]), childNodes.length ? styleElement.insertBefore(cssNode, childNodes[index]) : styleElement.appendChild(cssNode);
            }
        }
        function applyToTag(styleElement, obj) {
            var css = obj.css, media = obj.media;
            if (media && styleElement.setAttribute("media", media), styleElement.styleSheet) styleElement.styleSheet.cssText = css; else {
                for (;styleElement.firstChild; ) styleElement.removeChild(styleElement.firstChild);
                styleElement.appendChild(document.createTextNode(css));
            }
        }
        function updateLink(linkElement, obj) {
            var css = obj.css, sourceMap = obj.sourceMap;
            sourceMap && (// http://stackoverflow.com/a/26603875
            css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */");
            var blob = new Blob([ css ], {
                type: "text/css"
            }), oldSrc = linkElement.href;
            linkElement.href = URL.createObjectURL(blob), oldSrc && URL.revokeObjectURL(oldSrc);
        }
        /*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
        var stylesInDom = {}, memoize = function(fn) {
            var memo;
            return function() {
                return "undefined" == typeof memo && (memo = fn.apply(this, arguments)), memo;
            };
        }, isOldIE = memoize(function() {
            return /msie [6-9]\b/.test(window.navigator.userAgent.toLowerCase());
        }), getHeadElement = memoize(function() {
            return document.head || document.getElementsByTagName("head")[0];
        }), singletonElement = null, singletonCounter = 0, styleElementsInsertedAtTop = [];
        module.exports = function(list, options) {
            options = options || {}, // Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
            // tags it will allow on a page
            "undefined" == typeof options.singleton && (options.singleton = isOldIE()), // By default, add <style> tags to the bottom of <head>.
            "undefined" == typeof options.insertAt && (options.insertAt = "bottom");
            var styles = listToStyles(list);
            return addStylesToDom(styles, options), function(newList) {
                for (var mayRemove = [], i = 0; i < styles.length; i++) {
                    var item = styles[i], domStyle = stylesInDom[item.id];
                    domStyle.refs--, mayRemove.push(domStyle);
                }
                if (newList) {
                    var newStyles = listToStyles(newList);
                    addStylesToDom(newStyles, options);
                }
                for (var i = 0; i < mayRemove.length; i++) {
                    var domStyle = mayRemove[i];
                    if (0 === domStyle.refs) {
                        for (var j = 0; j < domStyle.parts.length; j++) domStyle.parts[j]();
                        delete stylesInDom[domStyle.id];
                    }
                }
            };
        };
        var replaceText = function() {
            var textStore = [];
            return function(index, replacement) {
                return textStore[index] = replacement, textStore.filter(Boolean).join("\n");
            };
        }();
    }, /* 7 */
    /***/
    function(module, exports, __webpack_require__) {
        exports = module.exports = __webpack_require__(5)(), // imports
        // module
        exports.push([ module.id, "._3gYZ_y6ZGYy1iiwnwF0IAn{border-radius:3px;box-sizing:border-box;display:-webkit-inline-box;display:inline-flex;font-size:11px;font-weight:700;line-height:1;max-width:200px;padding:2px 4px 3px;text-transform:uppercase;vertical-align:baseline;white-space:nowrap}.QMe5JXZA80tcOyv1n6TUP{display:inline-block;overflow:hidden;text-overflow:ellipsis}.h4MwqeVnS3URyoNhqd_8p{background:#eceef1;color:#42526e}.h4MwqeVnS3URyoNhqd_8p[bold]{background:#cfd4db;color:#253858}._1_JrYMW7hwOMRVj9uU6wZ{background:#e2ffee;color:#008364}._1_JrYMW7hwOMRVj9uU6wZ[bold]{background:#008364;color:#fff}.VGziEGICtgeF8FIY3d0-f{background:#ffe1e4;color:#bf2117}.VGziEGICtgeF8FIY3d0-f[bold]{background:#bf2117;color:#fff}.Uq3w1f6lRTeb3PznoBxIp{background:#bfebff;color:#1251ae}.Uq3w1f6lRTeb3PznoBxIp[bold]{background:#1251ae;color:#fff}._24wJ3mmldsSJNn3m2zUEiz{background:#e3e8f5;color:#3e3678}._24wJ3mmldsSJNn3m2zUEiz[bold]{background:#3e3678;color:#fff}._3PgSa2R6RpdIXvpMomul7Z{background:#fff6c9;color:#344563}._3PgSa2R6RpdIXvpMomul7Z[bold]{background:#ff991f;color:#344563}", "" ]), 
        // exports
        exports.locals = {
            lozenge: "_3gYZ_y6ZGYy1iiwnwF0IAn",
            lozenge: "_3gYZ_y6ZGYy1iiwnwF0IAn",
            content: "QMe5JXZA80tcOyv1n6TUP",
            content: "QMe5JXZA80tcOyv1n6TUP",
            "default": "h4MwqeVnS3URyoNhqd_8p",
            "default": "h4MwqeVnS3URyoNhqd_8p",
            success: "_1_JrYMW7hwOMRVj9uU6wZ",
            success: "_1_JrYMW7hwOMRVj9uU6wZ",
            removed: "VGziEGICtgeF8FIY3d0-f",
            removed: "VGziEGICtgeF8FIY3d0-f",
            inprogress: "Uq3w1f6lRTeb3PznoBxIp",
            inprogress: "Uq3w1f6lRTeb3PznoBxIp",
            "new": "_24wJ3mmldsSJNn3m2zUEiz",
            "new": "_24wJ3mmldsSJNn3m2zUEiz",
            moved: "_3PgSa2R6RpdIXvpMomul7Z",
            moved: "_3PgSa2R6RpdIXvpMomul7Z"
        };
    }, /* 8 */
    /***/
    function(module, exports, __webpack_require__) {
        !function(global, factory) {
            factory(exports, __webpack_require__(9));
        }(this, function(exports, incrementalDom) {
            function empty(val) {
                return "undefined" == typeof val || null === val;
            }
            function create(def) {
                return function() {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
                    return args.unshift({}, def), assign$1.apply(void 0, args);
                };
            }
            function enter(object, props) {
                var saved = {};
                return Object.keys(props).forEach(function(key) {
                    saved[key] = object[key], object[key] = props[key];
                }), saved;
            }
            function exit(object, saved) {
                assign$1(object, saved);
            }
            // Decorates a function with a side effect that changes the properties of an
            // object during its execution, and restores them after. There is no error
            // handling here, if the wrapped function throws an error, properties are not
            // restored and all bets are off.
            function propContext(object, props) {
                return function(func) {
                    return function() {
                        var saved = enter(object, props), result = func.apply(void 0, arguments);
                        return exit(object, saved), result;
                    };
                };
            }
            // Adds or removes an event listener for an element.
            function applyEvent(elem, ename, newFunc) {
                var events = elem[$currentEventHandlers];
                events || (events = elem[$currentEventHandlers] = {});
                var oldFunc = events[ename];
                // Remove old listener so they don't double up.
                oldFunc && elem.removeEventListener(ename, oldFunc), // Bind new listener.
                newFunc && elem.addEventListener(ename, events[ename] = newFunc);
            }
            function resolveTagName(tname) {
                // If the tag name is a function, a Skate constructor or a standard function
                // is supported.
                //
                // - If a Skate constructor, the tag name is extracted from that.
                // - If a standard function, it is used as a helper.
                // If the tag name is a function, a Skate constructor or a standard function
                // is supported.
                //
                // - If a Skate constructor, the tag name is extracted from that.
                // - If a standard function, it is used as a helper.
                // Skate allows the consumer to use <slot /> and it will translate it to
                // <content /> if Shadow DOM V0 is preferred.
                return "function" == typeof tname ? tname[$name] || tname : "slot" === tname && fallbackToV0 ? "content" : tname;
            }
            function elementOpenStart(tag) {
                var key = arguments.length <= 1 || void 0 === arguments[1] ? null : arguments[1], statics = arguments.length <= 2 || void 0 === arguments[2] ? null : arguments[2];
                overrideArgs = [ tag, key, statics ];
            }
            function elementOpenEnd() {
                var node = newElementOpen.apply(void 0, toConsumableArray(overrideArgs));
                // eslint-disable-line no-use-before-define
                return overrideArgs = null, node;
            }
            function wrapIdomFunc(func) {
                var tnameFuncHandler = arguments.length <= 1 || void 0 === arguments[1] ? noop : arguments[1];
                return function wrap() {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
                    if (args[0] = resolveTagName(args[0]), stackCurrentHelper = null, "function" == typeof args[0]) // If we've encountered a function, handle it according to the type of
                    // function that is being wrapped.
                    return stackCurrentHelper = args[0], tnameFuncHandler.apply(void 0, args);
                    if (stackChren.length) // We pass the wrap() function in here so that when it's called as
                    // children, it will queue up for the next stack, if there is one.
                    stackChren[stackChren.length - 1].push([ wrap, args ]); else {
                        if (func === elementOpen$1) {
                            if (skips) return ++skips;
                            var elem = func.apply(void 0, args);
                            return elem[$skip] && ++skips, elem;
                        }
                        if (func === incrementalDom.elementClose) {
                            // We only want to skip closing if it's not the last closing tag in the
                            // skipped tree because we keep the element that initiated the skpping.
                            if (1 === skips && incrementalDom.skip(), skips && --skips) return;
                            var _elem = func.apply(void 0, args), ref = _elem[$ref];
                            // We delete so that it isn't called again for the same element. If the
                            // ref changes, or the element changes, this will be defined again.
                            // Execute the saved ref after esuring we've cleand up after it.
                            return delete _elem[$ref], "function" == typeof ref && ref(_elem), _elem;
                        }
                        // We must call elementOpenStart and elementOpenEnd even if we are
                        // skipping because they queue up attributes and then call elementClose.
                        if (!skips || func === elementOpenStart || func === elementOpenEnd) return func.apply(void 0, args);
                    }
                };
            }
            function newAttr() {
                for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) args[_key2] = arguments[_key2];
                stackCurrentHelper ? stackCurrentHelper[$stackCurrentHelperProps][args[0]] = args[1] : stackChren.length ? stackChren[stackChren.length - 1].push([ newAttr, args ]) : (overrideArgs.push(args[0]), 
                overrideArgs.push(args[1]));
            }
            function stackOpen(tname, key, statics) {
                for (var props = {
                    key: key,
                    statics: statics
                }, _len3 = arguments.length, attrs = Array(_len3 > 3 ? _len3 - 3 : 0), _key3 = 3; _key3 < _len3; _key3++) attrs[_key3 - 3] = arguments[_key3];
                for (var a = 0; a < attrs.length; a += 2) props[attrs[a]] = attrs[a + 1];
                tname[$stackCurrentHelperProps] = props, stackChren.push([]);
            }
            function stackClose(tname) {
                var chren = stackChren.pop(), props = tname[$stackCurrentHelperProps];
                return delete tname[$stackCurrentHelperProps], tname(props, function() {
                    return chren.forEach(function(args) {
                        return args[0].apply(args, toConsumableArray(args[1]));
                    });
                });
            }
            // Ensure we call our overridden functions instead of the internal ones.
            function newElementVoid(tag) {
                for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) args[_key4 - 1] = arguments[_key4];
                return newElementOpen.apply(void 0, [ tag ].concat(args)), newElementClose(tag);
            }
            // Convenience function for declaring an Incremental DOM element using
            // hyperscript-style syntax.
            function element(tname, attrs, chren) {
                var atype = "undefined" == typeof attrs ? "undefined" : _typeof(attrs);
                // If attributes are a function, then they should be treated as children.
                "function" !== atype && "string" !== atype && "number" !== atype || (chren = attrs), 
                // Ensure the attributes are an object.
                "object" !== atype && (attrs = {}), // We open the element so we can set attrs after.
                newElementOpenStart(tname, attrs.key, attrs.statics), // Delete so special attrs don't actually get set.
                delete attrs.key, delete attrs.statics, // Set attributes.
                Object.keys(attrs).forEach(function(name) {
                    return newAttr(name, attrs[name]);
                }), // Close before we render the descendant tree.
                newElementOpenEnd(tname);
                var ctype = "undefined" == typeof chren ? "undefined" : _typeof(chren);
                return "function" === ctype ? chren() : "string" !== ctype && "number" !== ctype || newText(chren), 
                newElementClose(tname);
            }
            function data(element) {
                var namespace = arguments.length <= 1 || void 0 === arguments[1] ? "" : arguments[1], data = element.__SKATE_DATA || (element.__SKATE_DATA = {});
                return namespace && (data[namespace] || (data[namespace] = {})) || data;
            }
            function debounce(fn) {
                var _this = this, called = !1;
                return function() {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
                    called || (called = !0, setTimeout(function() {
                        called = !1, fn.apply(_this, args);
                    }));
                };
            }
            function getOwnPropertyDescriptors(obj) {
                return Object.getOwnPropertyNames(obj || {}).reduce(function(prev, curr) {
                    return prev[curr] = Object.getOwnPropertyDescriptor(obj, curr), prev;
                }, {});
            }
            function callConstructor(elem) {
                var elemData = data(elem), readyCallbacks = elemData.readyCallbacks, Ctor = elem.constructor, created = Ctor.created, observedAttributes = Ctor.observedAttributes, props = Ctor.props;
                // Ensures that this can never be called twice.
                elem[$created] || (elem[$created] = !0, // Set up a renderer that is debounced for property sets to call directly.
                elem[$rendererDebounced] = debounce(Ctor[$renderer]), props && Ctor[$props](elem), 
                created && created(elem), elem.setAttribute("defined", ""), readyCallbacks && (readyCallbacks.forEach(function(cb) {
                    return cb(elem);
                }), delete elemData.readyCallbacks), // In v0 we must ensure the attributeChangedCallback is called for attrs
                // that aren't linked to props so that the callback behaves the same no
                // matter if v0 or v1 is being used.
                customElementsV0 && observedAttributes.forEach(function(name) {
                    var propertyName = data(elem, "attributeLinks")[name];
                    propertyName || elem.attributeChangedCallback(name, null, elem.getAttribute(name));
                }));
            }
            function callConnected(elem) {
                var ctor = elem.constructor, attached = ctor.attached, render = ctor[$renderer];
                elem[$connected] = !0, "function" == typeof render && render(elem), "function" == typeof attached && attached(elem);
            }
            function callDisconnected(elem) {
                var detached = elem.constructor.detached;
                elem[$connected] = !1, "function" == typeof detached && detached(elem);
            }
            // v1
            function Component(self) {
                var elem = HTMLElement.call(this, self);
                return callConstructor(elem), elem;
            }
            function get$1(elem) {
                var props = {};
                return Object.keys(elem.constructor.props).forEach(function(key) {
                    props[key] = elem[key];
                }), props;
            }
            function set$1(elem, newProps) {
                assign$1(elem, newProps), elem.constructor.render && elem.constructor[$renderer](elem);
            }
            function props(elem, newProps) {
                return "undefined" == typeof newProps ? get$1(elem) : set$1(elem, newProps);
            }
            function createRenderer(Ctor) {
                var render = Ctor.render, rendered = Ctor.rendered, updated = Ctor.updated;
                return function(elem) {
                    if (!elem[$rendering] && elem[$connected]) {
                        // Flag as rendering. This prevents anything from trying to render - or
                        // queueing a render - while there is a pending render.
                        elem[$rendering] = !0;
                        // Call the updated() callback to see if we should render.
                        var shouldRender = !0;
                        if (updated) {
                            var prev = elem[$props];
                            elem[$props] = props(elem), shouldRender = updated(elem, prev);
                        }
                        // Even though this would ideally be checked in the updated() callback,
                        // it may not be, so we ensure that there is a point in proceeding.
                        if (!render) return void (elem[$rendering] = !1);
                        // Try and get the current shadow root (will be setup if not).
                        var sr = elem[$shadowRoot];
                        // Setup the shadow root if it hasn't been setup yet.
                        sr || (sr = shadowDomV1 ? elem.attachShadow({
                            mode: "open"
                        }) : shadowDomV0 ? elem.createShadowRoot() : elem, elem[$shadowRoot] = sr), shouldRender && (incrementalDom.patchInner(sr, render, elem), 
                        rendered && rendered(elem)), elem[$rendering] = !1;
                    }
                };
            }
            function dashCase(str) {
                return str.split(/([A-Z])/).reduce(function(one, two, idx) {
                    var dash = one && idx % 2 !== 0 ? "-" : "";
                    return "" + one + dash + two.toLowerCase();
                });
            }
            function getDefaultValue(elem, name, opts) {
                return "function" == typeof opts["default"] ? opts["default"](elem, {
                    name: name
                }) : opts["default"];
            }
            function getInitialValue(elem, name, opts) {
                return "function" == typeof opts.initial ? opts.initial(elem, {
                    name: name
                }) : opts.initial;
            }
            function createNativePropertyDefinition(name, opts) {
                var prop = {
                    configurable: !0,
                    enumerable: !0
                };
                return prop.created = function(elem) {
                    // eslint-disable-line func-names
                    var propData = data(elem, "api/property/" + name), attributeName = opts.attribute === !0 ? dashCase(name) : opts.attribute, initialValue = elem[name], shouldSyncAttribute = !1;
                    // Store property to attribute link information.
                    data(elem, "attributeLinks")[attributeName] = name, data(elem, "propertyLinks")[name] = attributeName, 
                    // Set up initial value if it wasn't specified.
                    empty(initialValue) && (attributeName && elem.hasAttribute(attributeName) ? initialValue = opts.deserialize(elem.getAttribute(attributeName)) : "initial" in opts ? (initialValue = getInitialValue(elem, name, opts), 
                    shouldSyncAttribute = !0) : "default" in opts && (initialValue = getDefaultValue(elem, name, opts))), 
                    shouldSyncAttribute ? prop.set.call(elem, initialValue) : propData.internalValue = opts.coerce ? opts.coerce(initialValue) : initialValue;
                }, prop.get = function() {
                    // eslint-disable-line func-names
                    var propData = data(this, "api/property/" + name), internalValue = propData.internalValue;
                    return "function" == typeof opts.get ? opts.get(this, {
                        name: name,
                        internalValue: internalValue
                    }) : internalValue;
                }, prop.set = function(newValue) {
                    // eslint-disable-line func-names
                    var propData = data(this, "api/property/" + name), oldValue = propData.oldValue, shouldRemoveAttribute = !1;
                    empty(oldValue) && (oldValue = null), empty(newValue) && (newValue = getDefaultValue(this, name, opts), 
                    shouldRemoveAttribute = !0), "function" == typeof opts.coerce && (newValue = opts.coerce(newValue)), 
                    propData.internalValue = newValue;
                    var changeData = {
                        name: name,
                        newValue: newValue,
                        oldValue: oldValue
                    };
                    "function" == typeof opts.set && opts.set(this, changeData), // Queue a re-render only if it's not currently rendering.
                    this[$rendering] || this[$rendererDebounced](this), propData.oldValue = newValue;
                    // Link up the attribute.
                    var attributeName = data(this, "propertyLinks")[name];
                    if (attributeName && !propData.settingAttribute) {
                        var serializedValue = opts.serialize(newValue), currentAttrValue = this.getAttribute(attributeName), serializedIsEmpty = empty(serializedValue), attributeChanged = !(serializedIsEmpty && empty(currentAttrValue) || serializedValue === currentAttrValue);
                        propData.syncingAttribute = !0, shouldRemoveAttribute || serializedIsEmpty ? this.removeAttribute(attributeName) : this.setAttribute(attributeName, serializedValue), 
                        !attributeChanged && propData.syncingAttribute && (propData.syncingAttribute = !1);
                    }
                    // Allow the attribute to be linked again.
                    propData.settingAttribute = !1;
                }, prop;
            }
            function initProps(opts) {
                return opts = opts || {}, "function" == typeof opts && (opts = {
                    coerce: opts
                }), function(name) {
                    return createNativePropertyDefinition(name, assign$1({
                        "default": null,
                        deserialize: function(value) {
                            return value;
                        },
                        serialize: function(value) {
                            return value;
                        }
                    }, opts));
                };
            }
            // Ensures that definitions passed as part of the constructor are functions
            // that return property definitions used on the element.
            function ensurePropertyFunctions(Ctor) {
                var props = Ctor.props, names = Object.keys(props || {});
                return names.reduce(function(descriptors, descriptorName) {
                    return descriptors[descriptorName] = props[descriptorName], "function" != typeof descriptors[descriptorName] && (descriptors[descriptorName] = initProps(descriptors[descriptorName])), 
                    descriptors;
                }, {});
            }
            // Ensures the property definitions are transformed to objects that can be used
            // to create properties on the element.
            function ensurePropertyDefinitions(Ctor) {
                var props = ensurePropertyFunctions(Ctor);
                return Object.keys(props).reduce(function(descriptors, descriptorName) {
                    return descriptors[descriptorName] = props[descriptorName](descriptorName), descriptors;
                }, {});
            }
            // Ensures linked properties that have linked attributes are pre-formatted to
            // the attribute name in which they are linked.
            function formatLinkedAttributes(Ctor) {
                var observedAttributes = Ctor.observedAttributes, props = Ctor.props;
                props && (Object.keys(props).forEach(function(name) {
                    var prop = props[name], attr = prop.attribute;
                    if (attr) {
                        // Ensure the property is updated.
                        var linkedAttr = prop.attribute = attr === !0 ? dashCase(name) : attr;
                        // Automatically observe the attribute since they're linked from the
                        // attributeChangedCallback.
                        observedAttributes.indexOf(linkedAttr) === -1 && observedAttributes.push(linkedAttr);
                    }
                }), // Merge observed attributes.
                Object.defineProperty(Ctor, "observedAttributes", {
                    configurable: !0,
                    enumerable: !0,
                    get: function() {
                        return observedAttributes;
                    }
                }));
            }
            function createInitProps(Ctor) {
                var props = ensurePropertyDefinitions(Ctor);
                return function(elem) {
                    props && Object.keys(props).forEach(function(name) {
                        var prop = props[name];
                        prop.created(elem), // https://bugs.webkit.org/show_bug.cgi?id=49739
                        //
                        // When Webkit fixes that bug so that native property accessors can be
                        // retrieved, we can move defining the property to the prototype and away
                        // from having to do if for every instance as all other browsers support
                        // this.
                        Object.defineProperty(elem, name, prop);
                    });
                };
            }
            function generateUniqueName(name) {
                // http://stackoverflow.com/questions/105034/create-guid-uuid-in-javascript/2117523#2117523
                var rand = "xxxxxxxx".replace(/[xy]/g, function(c) {
                    var r = 16 * Math.random() | 0, v = "x" === c ? r : 3 & r | 8;
                    // eslint-disable-line no-mixed-operators
                    return v.toString(16);
                });
                return name + "-" + rand;
            }
            function prepareForRegistration(name, Ctor) {
                Ctor[$name] = name, Ctor[$props] = createInitProps(Ctor), Ctor[$renderer] = createRenderer(Ctor);
            }
            function registerV0Element(name, Ctor) {
                var res = void 0, uniqueName = void 0;
                try {
                    prepareForRegistration(name, Ctor), res = document.registerElement(name, Ctor);
                } catch (e) {
                    uniqueName = generateUniqueName(name), prepareForRegistration(uniqueName, Ctor), 
                    res = document.registerElement(uniqueName, Ctor);
                }
                return res;
            }
            function registerV1Element(name, Ctor) {
                var uniqueName = name;
                return window.customElements.get(name) && (uniqueName = generateUniqueName(name)), 
                prepareForRegistration(uniqueName, Ctor), window.customElements.define(uniqueName, Ctor, {
                    "extends": Ctor["extends"]
                }), Ctor;
            }
            function define(name, opts) {
                if (void 0 === opts) throw new Error("You have to define options to register a component " + name);
                var Ctor = "object" === ("undefined" == typeof opts ? "undefined" : _typeof(opts)) ? Component.extend(opts) : opts;
                if (formatLinkedAttributes(Ctor), customElementsV1) return registerV1Element(name, Ctor);
                if (customElementsV0) return registerV0Element(name, Ctor);
                throw new Error("Skate requires native custom element support or a polyfill.");
            }
            function createCustomEvent(name) {
                var opts = arguments.length <= 1 || void 0 === arguments[1] ? {} : arguments[1], detail = opts.detail;
                delete opts.detail;
                var e = void 0;
                return Event ? (e = new Event(name, opts), "undefined" != typeof detail && Object.defineProperty(e, "detail", {
                    value: detail
                })) : (e = document.createEvent("CustomEvent"), e.initCustomEvent(name, opts.bubbles, opts.cancelable, detail)), 
                e;
            }
            function emit(elem, name) {
                var opts = arguments.length <= 2 || void 0 === arguments[2] ? {} : arguments[2];
                return void 0 === opts.bubbles && (opts.bubbles = !0), void 0 === opts.cancelable && (opts.cancelable = !0), 
                void 0 === opts.composed && (opts.composed = !0), elem.dispatchEvent(createCustomEvent(name, opts));
            }
            function getValue(elem) {
                var type = elem.type;
                return "checkbox" === type || "radio" === type ? !!elem.checked && (elem.value || !0) : elem.value;
            }
            function link(elem, target) {
                return function(e) {
                    var value = getValue(e.target), localTarget = target || e.target.name || "value";
                    if (localTarget.indexOf(".") > -1) {
                        var parts = localTarget.split("."), firstPart = parts[0], propName = parts.pop(), obj = parts.reduce(function(prev, curr) {
                            return prev && prev[curr];
                        }, elem);
                        obj[propName || e.target.name] = value, props(elem, defineProperty({}, firstPart, elem[firstPart]));
                    } else props(elem, defineProperty({}, localTarget, value));
                };
            }
            function ready(elem, done) {
                var info = data(elem);
                elem[$created] ? done(elem) : info.readyCallbacks ? info.readyCallbacks.push(done) : info.readyCallbacks = [ done ];
            }
            var assign = Object.assign, assign$1 = assign ? assign.bind(Object) : function(obj) {
                for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) args[_key - 1] = arguments[_key];
                // eslint-disable-line no-return-assign
                return args.forEach(function(arg) {
                    return Object.keys(arg).forEach(function(name) {
                        return obj[name] = arg[name];
                    });
                }), obj;
            }, alwaysUndefinedIfNotANumberOrNumber = function(val) {
                return isNaN(val) ? void 0 : Number(val);
            }, alwaysUndefinedIfEmptyOrString = function(val) {
                return empty(val) ? void 0 : String(val);
            }, array = create({
                coerce: function(val) {
                    return Array.isArray(val) ? val : [ val ];
                },
                "default": function() {
                    return [];
                },
                deserialize: JSON.parse,
                serialize: JSON.stringify
            }), boolean = create({
                coerce: function(value) {
                    return !!value;
                },
                "default": !1,
                deserialize: function(value) {
                    return !(null === value);
                },
                serialize: function(value) {
                    return value ? "" : void 0;
                }
            }), number = create({
                "default": 0,
                coerce: alwaysUndefinedIfNotANumberOrNumber,
                deserialize: alwaysUndefinedIfNotANumberOrNumber,
                serialize: alwaysUndefinedIfNotANumberOrNumber
            }), string = create({
                "default": "",
                coerce: alwaysUndefinedIfEmptyOrString,
                deserialize: alwaysUndefinedIfEmptyOrString,
                serialize: alwaysUndefinedIfEmptyOrString
            }), prop = Object.freeze({
                create: create,
                array: array,
                "boolean": boolean,
                number: number,
                string: string
            }), $connected = "____skate_connected", $created = "____skate_created", $name = "____skate_name", $props = "____skate_props", $ref = "____skate_ref", $renderer = "____skate_renderer", $rendering = "____skate_rendering", $rendererDebounced = "____skate_rendererDebounced", $shadowRoot = "____skate_shadowRoot", symbols$1 = Object.freeze({
                name: $name,
                shadowRoot: $shadowRoot
            }), doc = document, win = window, div = doc.createElement("div"), customElementsV0 = !!doc.registerElement, customElementsV1 = !!win.customElements, shadowDomV0 = !!div.createShadowRoot, shadowDomV1 = !!div.attachShadow, _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
                return typeof obj;
            } : function(obj) {
                return obj && "function" == typeof Symbol && obj.constructor === Symbol ? "symbol" : typeof obj;
            }, classCallCheck = function(instance, Constructor) {
                if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
            }, defineProperty = function(obj, key, value) {
                return key in obj ? Object.defineProperty(obj, key, {
                    value: value,
                    enumerable: !0,
                    configurable: !0,
                    writable: !0
                }) : obj[key] = value, obj;
            }, inherits = function(subClass, superClass) {
                if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
                subClass.prototype = Object.create(superClass && superClass.prototype, {
                    constructor: {
                        value: subClass,
                        enumerable: !1,
                        writable: !0,
                        configurable: !0
                    }
                }), superClass && (Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass);
            }, possibleConstructorReturn = function(self, call) {
                if (!self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return !call || "object" != typeof call && "function" != typeof call ? self : call;
            }, toConsumableArray = function(arr) {
                if (Array.isArray(arr)) {
                    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];
                    return arr2;
                }
                return Array.from(arr);
            }, applyDefault = incrementalDom.attributes[incrementalDom.symbols["default"]], fallbackToV0 = !shadowDomV1 && shadowDomV0, stackChren = [], $skip = "__skip", $currentEventHandlers = "__events", $stackCurrentHelperProps = "__props", stackCurrentHelper = void 0, overrideArgs = void 0, skips = 0, noop = function() {}, attributesContext = propContext(incrementalDom.attributes, defineProperty({
                // Attributes that shouldn't be applied to the DOM.
                key: noop,
                statics: noop,
                // Attributes that *must* be set via a property on all elements.
                checked: incrementalDom.applyProp,
                className: incrementalDom.applyProp,
                disabled: incrementalDom.applyProp,
                value: incrementalDom.applyProp,
                // V0 Shadow DOM to V1 normalisation.
                name: function(elem, _name, value) {
                    "CONTENT" === elem.tagName && (_name = "select", value = '[slot="' + value + '"]'), 
                    applyDefault(elem, _name, value);
                },
                // Ref handler.
                ref: function(elem, name, value) {
                    elem[$ref] = value;
                },
                // Skip handler.
                skip: function(elem, name, value) {
                    value ? elem[$skip] = !0 : delete elem[$skip];
                }
            }, incrementalDom.symbols["default"], function(elem, name, value) {
                // Custom element properties should be set as properties.
                var props = elem.constructor.props;
                if (props && name in props) return incrementalDom.applyProp(elem, name, value);
                // Boolean false values should not set attributes at all.
                if (value !== !1) {
                    // Handle built-in and custom events.
                    if (0 === name.indexOf("on")) {
                        var firstChar = name[2], eventName = void 0;
                        if ("-" === firstChar ? eventName = name.substring(3) : firstChar === firstChar.toUpperCase() && (eventName = firstChar.toLowerCase() + name.substring(3)), 
                        eventName) return void applyEvent(elem, eventName, value);
                    }
                    // Set defined props on the element directly. This ensures properties like
                    // "value" on <input> elements get set correctly. Setting those as attributes
                    // doesn't always work and setting props is faster than attributes.
                    //
                    // However, certain props on SVG elements are readonly and error when you try
                    // to set them.
                    // Set defined props on the element directly. This ensures properties like
                    // "value" on <input> elements get set correctly. Setting those as attributes
                    // doesn't always work and setting props is faster than attributes.
                    //
                    // However, certain props on SVG elements are readonly and error when you try
                    // to set them.
                    // Fallback to default IncrementalDOM behaviour.
                    return name in elem && !("ownerSVGElement" in elem) ? void incrementalDom.applyProp(elem, name, value) : void applyDefault(elem, name, value);
                }
            })), elementOpen$1 = attributesContext(incrementalDom.elementOpen), newElementOpenStart = wrapIdomFunc(elementOpenStart, stackOpen), newElementOpenEnd = wrapIdomFunc(elementOpenEnd), newElementOpen = wrapIdomFunc(elementOpen$1, stackOpen), newElementClose = wrapIdomFunc(incrementalDom.elementClose, stackClose), newText = wrapIdomFunc(incrementalDom.text), vdom = Object.freeze({
                element: element,
                attr: newAttr,
                elementClose: newElementClose,
                elementOpen: newElementOpen,
                elementOpenEnd: newElementOpenEnd,
                elementOpenStart: newElementOpenStart,
                elementVoid: newElementVoid,
                text: newText
            });
            Object.defineProperties(Component, {
                // v1
                observedAttributes: {
                    configurable: !0,
                    get: function() {
                        return [];
                    }
                },
                // Skate
                props: {
                    configurable: !0,
                    get: function() {
                        return {};
                    }
                }
            }), // Skate
            Component.extend = function() {
                var definition = arguments.length <= 0 || void 0 === arguments[0] ? {} : arguments[0], Base = arguments.length <= 1 || void 0 === arguments[1] ? this : arguments[1], Ctor = function(_Base) {
                    function Ctor() {
                        return classCallCheck(this, Ctor), possibleConstructorReturn(this, (Ctor.__proto__ || Object.getPrototypeOf(Ctor)).apply(this, arguments));
                    }
                    return inherits(Ctor, _Base), Ctor;
                }(Base);
                // Pass on statics from the Base if not supported (IE 9 and 10).
                if (!Ctor.observedAttributes) {
                    var staticOpts = getOwnPropertyDescriptors(Base);
                    delete staticOpts.length, delete staticOpts.prototype, Object.defineProperties(Ctor, staticOpts);
                }
                // For inheriting from the object literal.
                var opts = getOwnPropertyDescriptors(definition), prot = getOwnPropertyDescriptors(definition.prototype);
                // Prototype is non configurable (but is writable).
                // Pass on static and instance members from the definition.
                return delete opts.prototype, Object.defineProperties(Ctor, opts), Object.defineProperties(Ctor.prototype, prot), 
                Ctor;
            }, // Skate
            //
            // This is a default implementation that does strict equality copmarison on
            // prevoius props and next props. It synchronously renders on the first prop
            // that is different and returns immediately.
            Component.updated = function(elem, prev) {
                if (!prev) return !0;
                // eslint-disable-next-line no-restricted-syntax
                for (var name in prev) if (prev[name] !== elem[name]) return !0;
            }, Component.prototype = Object.create(HTMLElement.prototype, {
                // v1
                connectedCallback: {
                    configurable: !0,
                    value: function() {
                        callConnected(this);
                    }
                },
                // v1
                disconnectedCallback: {
                    configurable: !0,
                    value: function() {
                        callDisconnected(this);
                    }
                },
                // v0 and v1
                attributeChangedCallback: {
                    configurable: !0,
                    value: function(name, oldValue, newValue) {
                        var _constructor = this.constructor, attributeChanged = _constructor.attributeChanged, observedAttributes = _constructor.observedAttributes, propertyName = data(this, "attributeLinks")[name];
                        // In V0 we have to ensure the attribute is being observed.
                        if (!customElementsV0 || observedAttributes.indexOf(name) !== -1) {
                            if (propertyName) {
                                var propData = data(this, "api/property/" + propertyName);
                                // This ensures a property set doesn't cause the attribute changed
                                // handler to run again once we set this flag. This only ever has a
                                // chance to run when you set an attribute, it then sets a property and
                                // then that causes the attribute to be set again.
                                if (propData.syncingAttribute) propData.syncingAttribute = !1; else {
                                    // Sync up the property.
                                    var propOpts = this.constructor.props[propertyName];
                                    propData.settingAttribute = !0, this[propertyName] = null !== newValue && propOpts.deserialize ? propOpts.deserialize(newValue) : newValue;
                                }
                            }
                            attributeChanged && attributeChanged(this, {
                                name: name,
                                newValue: newValue,
                                oldValue: oldValue
                            });
                        }
                    }
                },
                // v0
                createdCallback: {
                    configurable: !0,
                    value: function() {
                        callConstructor(this);
                    }
                },
                // v0
                attachedCallback: {
                    configurable: !0,
                    value: function() {
                        callConnected(this);
                    }
                },
                // v0
                detachedCallback: {
                    configurable: !0,
                    value: function() {
                        callDisconnected(this);
                    }
                }
            });
            var Event = function(TheEvent) {
                if (TheEvent) try {
                    new TheEvent("emit-init");
                } catch (e) {
                    return;
                }
                return TheEvent;
            }(window.Event);
            exports.Component = Component, exports.define = define, exports.emit = emit, exports.link = link, 
            exports.prop = prop, exports.props = props, exports.ready = ready, exports.symbols = symbols$1, 
            exports.vdom = vdom, Object.defineProperty(exports, "__esModule", {
                value: !0
            });
        });
    }, /* 9 */
    /***/
    function(module, exports, __webpack_require__) {
        /**
	 * @license
	 * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
	 *
	 * Licensed under the Apache License, Version 2.0 (the "License");
	 * you may not use this file except in compliance with the License.
	 * You may obtain a copy of the License at
	 *
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 * Unless required by applicable law or agreed to in writing, software
	 * distributed under the License is distributed on an "AS-IS" BASIS,
	 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	 * See the License for the specific language governing permissions and
	 * limitations under the License.
	 */
        "use strict";
        /**
	 * Keeps track of information needed to perform diffs for a given DOM node.
	 * @param {!string} nodeName
	 * @param {?string=} key
	 * @constructor
	 */
        function NodeData(nodeName, key) {
            /**
	   * The attributes and their values.
	   * @const {!Object<string, *>}
	   */
            this.attrs = createMap(), /**
	   * An array of attribute name/value pairs, used for quickly diffing the
	   * incomming attributes to see if the DOM node's attributes need to be
	   * updated.
	   * @const {Array<*>}
	   */
            this.attrsArr = [], /**
	   * The incoming attributes for this Node, before they are updated.
	   * @const {!Object<string, *>}
	   */
            this.newAttrs = createMap(), /**
	   * The key used to identify this node, used to preserve DOM nodes when they
	   * move within their parent.
	   * @const
	   */
            this.key = key, /**
	   * Keeps track of children within this node by their key.
	   * {?Object<string, !Element>}
	   */
            this.keyMap = null, /**
	   * Whether or not the keyMap is currently valid.
	   * {boolean}
	   */
            this.keyMapValid = !0, /**
	   * The node name for this node.
	   * @const {string}
	   */
            this.nodeName = nodeName, /**
	   * @type {?string}
	   */
            this.text = null;
        }
        /**
	 * Keeps track of the state of a patch.
	 * @constructor
	 */
        function Context() {
            /**
	   * @type {(Array<!Node>|undefined)}
	   */
            this.created = notifications.nodesCreated && [], /**
	   * @type {(Array<!Node>|undefined)}
	   */
            this.deleted = notifications.nodesDeleted && [];
        }
        /**
	 * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
	 *
	 * Licensed under the Apache License, Version 2.0 (the "License");
	 * you may not use this file except in compliance with the License.
	 * You may obtain a copy of the License at
	 *
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 * Unless required by applicable law or agreed to in writing, software
	 * distributed under the License is distributed on an "AS-IS" BASIS,
	 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	 * See the License for the specific language governing permissions and
	 * limitations under the License.
	 */
        /**
	 * A cached reference to the hasOwnProperty function.
	 */
        var hasOwnProperty = Object.prototype.hasOwnProperty, create = Object.create, has = function(map, property) {
            return hasOwnProperty.call(map, property);
        }, createMap = function() {
            return create(null);
        }, initData = function(node, nodeName, key) {
            var data = new NodeData(nodeName, key);
            return node.__incrementalDOMData = data, data;
        }, getData = function(node) {
            var data = node.__incrementalDOMData;
            if (!data) {
                var nodeName = node.nodeName.toLowerCase(), key = null;
                node instanceof Element && (key = node.getAttribute("key")), data = initData(node, nodeName, key);
            }
            return data;
        }, symbols = {
            "default": "__default",
            placeholder: "__placeholder"
        }, getNamespace = function(name) {
            return 0 === name.lastIndexOf("xml:", 0) ? "http://www.w3.org/XML/1998/namespace" : 0 === name.lastIndexOf("xlink:", 0) ? "http://www.w3.org/1999/xlink" : void 0;
        }, applyAttr = function(el, name, value) {
            if (null == value) el.removeAttribute(name); else {
                var attrNS = getNamespace(name);
                attrNS ? el.setAttributeNS(attrNS, name, value) : el.setAttribute(name, value);
            }
        }, applyProp = function(el, name, value) {
            el[name] = value;
        }, applyStyle = function(el, name, style) {
            if ("string" == typeof style) el.style.cssText = style; else {
                el.style.cssText = "";
                var elStyle = el.style, obj = /** @type {!Object<string,string>} */ style;
                for (var prop in obj) has(obj, prop) && (elStyle[prop] = obj[prop]);
            }
        }, applyAttributeTyped = function(el, name, value) {
            var type = typeof value;
            "object" === type || "function" === type ? applyProp(el, name, value) : applyAttr(el, name, /** @type {?(boolean|number|string)} */ value);
        }, updateAttribute = function(el, name, value) {
            var data = getData(el), attrs = data.attrs;
            if (attrs[name] !== value) {
                var mutator = attributes[name] || attributes[symbols["default"]];
                mutator(el, name, value), attrs[name] = value;
            }
        }, attributes = createMap();
        // Special generic mutator that's called for any attribute that does not
        // have a specific mutator.
        attributes[symbols["default"]] = applyAttributeTyped, attributes[symbols.placeholder] = function() {}, 
        attributes.style = applyStyle;
        /**
	 * Gets the namespace to create an element (of a given tag) in.
	 * @param {string} tag The tag to get the namespace for.
	 * @param {?Node} parent
	 * @return {?string} The namespace to create the tag in.
	 */
        var getNamespaceForTag = function(tag, parent) {
            return "svg" === tag ? "http://www.w3.org/2000/svg" : "foreignObject" === getData(parent).nodeName ? null : parent.namespaceURI;
        }, createElement = function(doc, parent, tag, key, statics) {
            var namespace = getNamespaceForTag(tag, parent), el = void 0;
            if (el = namespace ? doc.createElementNS(namespace, tag) : doc.createElement(tag), 
            initData(el, tag, key), statics) for (var i = 0; i < statics.length; i += 2) updateAttribute(el, /** @type {!string}*/ statics[i], statics[i + 1]);
            return el;
        }, createText = function(doc) {
            var node = doc.createTextNode("");
            return initData(node, "#text", null), node;
        }, createKeyMap = function(el) {
            for (var map = createMap(), child = el.firstElementChild; child; ) {
                var key = getData(child).key;
                key && (map[key] = child), child = child.nextElementSibling;
            }
            return map;
        }, getKeyMap = function(el) {
            var data = getData(el);
            return data.keyMap || (data.keyMap = createKeyMap(el)), data.keyMap;
        }, getChild = function(parent, key) {
            return key ? getKeyMap(parent)[key] : null;
        }, registerChild = function(parent, key, child) {
            getKeyMap(parent)[key] = child;
        }, notifications = {
            /**
	   * Called after patch has compleated with any Nodes that have been created
	   * and added to the DOM.
	   * @type {?function(Array<!Node>)}
	   */
            nodesCreated: null,
            /**
	   * Called after patch has compleated with any Nodes that have been removed
	   * from the DOM.
	   * Note it's an applications responsibility to handle any childNodes.
	   * @type {?function(Array<!Node>)}
	   */
            nodesDeleted: null
        };
        /**
	 * @param {!Node} node
	 */
        Context.prototype.markCreated = function(node) {
            this.created && this.created.push(node);
        }, /**
	 * @param {!Node} node
	 */
        Context.prototype.markDeleted = function(node) {
            this.deleted && this.deleted.push(node);
        }, /**
	 * Notifies about nodes that were created during the patch opearation.
	 */
        Context.prototype.notifyChanges = function() {
            this.created && this.created.length > 0 && notifications.nodesCreated(this.created), 
            this.deleted && this.deleted.length > 0 && notifications.nodesDeleted(this.deleted);
        };
        /**
	* Makes sure that keyed Element matches the tag name provided.
	* @param {!string} nodeName The nodeName of the node that is being matched.
	* @param {string=} tag The tag name of the Element.
	* @param {?string=} key The key of the Element.
	*/
        var context = null, currentNode = null, currentParent = null, root = null, doc = null, patchFactory = function(run) {
            /**
	   * TODO(moz): These annotations won't be necessary once we switch to Closure
	   * Compiler's new type inference. Remove these once the switch is done.
	   *
	   * @param {(!Element|!DocumentFragment)} node
	   * @param {!function(T)} fn
	   * @param {T=} data
	   * @template T
	   */
            var f = function(node, fn, data) {
                var prevContext = context, prevRoot = root, prevDoc = doc, prevCurrentNode = currentNode, prevCurrentParent = currentParent;
                context = new Context(), root = node, doc = node.ownerDocument, currentParent = node.parentNode, 
                run(node, fn, data), context.notifyChanges(), context = prevContext, root = prevRoot, 
                doc = prevDoc, currentNode = prevCurrentNode, currentParent = prevCurrentParent;
            };
            return f;
        }, patchInner = patchFactory(function(node, fn, data) {
            currentNode = node, enterNode(), fn(data), exitNode();
        }), patchOuter = patchFactory(function(node, fn, data) {
            currentNode = /** @type {!Element} */ {
                nextSibling: node
            }, fn(data);
        }), matches = function(nodeName, key) {
            var data = getData(currentNode);
            // Key check is done using double equals as we want to treat a null key the
            // same as undefined. This should be okay as the only values allowed are
            // strings, null and undefined so the == semantics are not too weird.
            return nodeName === data.nodeName && key == data.key;
        }, alignWithDOM = function(nodeName, key, statics) {
            if (!currentNode || !matches(nodeName, key)) {
                var node = void 0;
                // Check to see if the node has moved within the parent.
                key && (node = getChild(currentParent, key)), // Create the node if it doesn't exist.
                node || (node = "#text" === nodeName ? createText(doc) : createElement(doc, currentParent, nodeName, key, statics), 
                key && registerChild(currentParent, key, node), context.markCreated(node)), // If the node has a key, remove it from the DOM to prevent a large number
                // of re-orders in the case that it moved far or was completely removed.
                // Since we hold on to a reference through the keyMap, we can always add it
                // back.
                currentNode && getData(currentNode).key ? (currentParent.replaceChild(node, currentNode), 
                getData(currentParent).keyMapValid = !1) : currentParent.insertBefore(node, currentNode), 
                currentNode = node;
            }
        }, clearUnvisitedDOM = function() {
            var node = currentParent, data = getData(node), keyMap = data.keyMap, keyMapValid = data.keyMapValid, child = node.lastChild, key = void 0;
            if (!(child === currentNode && keyMapValid || data.attrs[symbols.placeholder] && node !== root)) {
                for (;child !== currentNode; ) node.removeChild(child), context.markDeleted(/** @type {!Node}*/ child), 
                key = getData(child).key, key && delete keyMap[key], child = node.lastChild;
                // Clean the keyMap, removing any unusued keys.
                if (!keyMapValid) {
                    for (key in keyMap) child = keyMap[key], child.parentNode !== node && (context.markDeleted(child), 
                    delete keyMap[key]);
                    data.keyMapValid = !0;
                }
            }
        }, enterNode = function() {
            currentParent = currentNode, currentNode = null;
        }, nextNode = function() {
            currentNode = currentNode ? currentNode.nextSibling : currentParent.firstChild;
        }, exitNode = function() {
            clearUnvisitedDOM(), currentNode = currentParent, currentParent = currentParent.parentNode;
        }, coreElementOpen = function(tag, key, statics) {
            return nextNode(), alignWithDOM(tag, key, statics), enterNode(), currentParent;
        }, coreElementClose = function() {
            return exitNode(), currentNode;
        }, coreText = function() {
            return nextNode(), alignWithDOM("#text", null, null), currentNode;
        }, currentElement = function() {
            return currentParent;
        }, skip = function() {
            currentNode = currentParent.lastChild;
        }, ATTRIBUTES_OFFSET = 3, argsBuilder = [], elementOpen = function(tag, key, statics, const_args) {
            for (var node = coreElementOpen(tag, key, statics), data = getData(node), attrsArr = data.attrsArr, newAttrs = data.newAttrs, attrsChanged = !1, i = ATTRIBUTES_OFFSET, j = 0; i < arguments.length; i += 1, 
            j += 1) if (attrsArr[j] !== arguments[i]) {
                attrsChanged = !0;
                break;
            }
            for (;i < arguments.length; i += 1, j += 1) attrsArr[j] = arguments[i];
            /*
	   * Actually perform the attribute update.
	   */
            if (j < attrsArr.length && (attrsChanged = !0, attrsArr.length = j), attrsChanged) {
                for (i = ATTRIBUTES_OFFSET; i < arguments.length; i += 2) newAttrs[arguments[i]] = arguments[i + 1];
                for (var _attr in newAttrs) updateAttribute(node, _attr, newAttrs[_attr]), newAttrs[_attr] = void 0;
            }
            return node;
        }, elementOpenStart = function(tag, key, statics) {
            argsBuilder[0] = tag, argsBuilder[1] = key, argsBuilder[2] = statics;
        }, attr = function(name, value) {
            argsBuilder.push(name, value);
        }, elementOpenEnd = function() {
            var node = elementOpen.apply(null, argsBuilder);
            return argsBuilder.length = 0, node;
        }, elementClose = function(tag) {
            var node = coreElementClose();
            return node;
        }, elementVoid = function(tag, key, statics, const_args) {
            return elementOpen.apply(null, arguments), elementClose(tag);
        }, elementPlaceholder = function(tag, key, statics, const_args) {
            return elementOpen.apply(null, arguments), skip(), elementClose(tag);
        }, text = function(value, const_args) {
            var node = coreText(), data = getData(node);
            if (data.text !== value) {
                data.text = /** @type {string} */ value;
                for (var formatted = value, i = 1; i < arguments.length; i += 1) {
                    /*
	       * Call the formatter function directly to prevent leaking arguments.
	       * https://github.com/google/incremental-dom/pull/204#issuecomment-178223574
	       */
                    var fn = arguments[i];
                    formatted = fn(formatted);
                }
                node.data = formatted;
            }
            return node;
        };
        exports.patch = patchInner, exports.patchInner = patchInner, exports.patchOuter = patchOuter, 
        exports.currentElement = currentElement, exports.skip = skip, exports.elementVoid = elementVoid, 
        exports.elementOpenStart = elementOpenStart, exports.elementOpenEnd = elementOpenEnd, 
        exports.elementOpen = elementOpen, exports.elementClose = elementClose, exports.elementPlaceholder = elementPlaceholder, 
        exports.text = text, exports.attr = attr, exports.symbols = symbols, exports.attributes = attributes, 
        exports.applyAttr = applyAttr, exports.applyProp = applyProp, exports.notifications = notifications;
    }, /* 10 */
    /***/
    function(module, exports, __webpack_require__) {
        var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;
        /*!
	  Copyright (c) 2016 Jed Watson.
	  Licensed under the MIT License (MIT), see
	  http://jedwatson.github.io/classnames
	*/
        /* global define */
        !function() {
            "use strict";
            function classNames() {
                for (var classes = [], i = 0; i < arguments.length; i++) {
                    var arg = arguments[i];
                    if (arg) {
                        var argType = typeof arg;
                        if ("string" === argType || "number" === argType) classes.push(arg); else if (Array.isArray(arg)) classes.push(classNames.apply(null, arg)); else if ("object" === argType) for (var key in arg) hasOwn.call(arg, key) && arg[key] && classes.push(key);
                    }
                }
                return classes.join(" ");
            }
            var hasOwn = {}.hasOwnProperty;
            "undefined" != typeof module && module.exports ? module.exports = classNames : (__WEBPACK_AMD_DEFINE_ARRAY__ = [], 
            __WEBPACK_AMD_DEFINE_RESULT__ = function() {
                return classNames;
            }.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__), // register as 'classnames', consistent with npm package name
            !(void 0 !== __WEBPACK_AMD_DEFINE_RESULT__ && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)));
        }();
    }, /* 11 */
    /***/
    function(module, exports, __webpack_require__) {
        "use strict";
        function _interopRequireDefault(obj) {
            return obj && obj.__esModule ? obj : {
                "default": obj
            };
        }
        Object.defineProperty(exports, "__esModule", {
            value: !0
        }), exports.KeyPressHandler = exports.keyCode = exports.enumeration = void 0;
        var _properties = __webpack_require__(12), _keycode = __webpack_require__(15), _keycode2 = _interopRequireDefault(_keycode), _index = __webpack_require__(16), _index2 = _interopRequireDefault(_index);
        exports.enumeration = _properties.enumeration, exports.keyCode = _keycode2["default"], 
        exports.KeyPressHandler = _index2["default"];
    }, /* 12 */
    /***/
    function(module, exports, __webpack_require__) {
        "use strict";
        function _interopRequireDefault(obj) {
            return obj && obj.__esModule ? obj : {
                "default": obj
            };
        }
        /* Helper function for creating new extensions to existing properties */
        function prop(def) {
            return function() {
                for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
                return args.unshift({}, def), _objectAssign2["default"].apply(null, args);
            };
        }
        /**
	  This property extension can be used with skate.
	  Usage:
	  ```
	  props: {
	      respondsTo: props.enum({values: ['toggle', 'hover'],
	      missingDefault: 'toggle',
	      invalidDefault: 'toggle'})({
	
	      })
	  }
	  ```
	 */
        function enumeration(enumOptions) {
            return prop({
                coerce: function(value) {
                    return (0, _attributes.computeEnumValue)(enumOptions, value);
                },
                "default": enumOptions.missingDefault,
                /* if the prop is an attribute, also add 'initial' with the default value so it get's set too*/
                initial: enumOptions.attribute ? enumOptions.missingDefault : void 0,
                deserialize: function(value) {
                    return null === value ? void 0 : value;
                },
                serialize: function(value) {
                    return "undefined" == typeof value ? value : String(value);
                }
            });
        }
        Object.defineProperty(exports, "__esModule", {
            value: !0
        }), exports.enumeration = void 0;
        var _objectAssign = __webpack_require__(13), _objectAssign2 = _interopRequireDefault(_objectAssign), _attributes = __webpack_require__(14);
        exports.enumeration = enumeration;
    }, /* 13 */
    /***/
    function(module, exports) {
        "use strict";
        function toObject(val) {
            if (null === val || void 0 === val) throw new TypeError("Object.assign cannot be called with null or undefined");
            return Object(val);
        }
        function shouldUseNative() {
            try {
                if (!Object.assign) return !1;
                // Detect buggy property enumeration order in older V8 versions.
                // https://bugs.chromium.org/p/v8/issues/detail?id=4118
                var test1 = new String("abc");
                if (// eslint-disable-line
                test1[5] = "de", "5" === Object.getOwnPropertyNames(test1)[0]) return !1;
                for (var test2 = {}, i = 0; i < 10; i++) test2["_" + String.fromCharCode(i)] = i;
                var order2 = Object.getOwnPropertyNames(test2).map(function(n) {
                    return test2[n];
                });
                if ("0123456789" !== order2.join("")) return !1;
                // https://bugs.chromium.org/p/v8/issues/detail?id=3056
                var test3 = {};
                return "abcdefghijklmnopqrst".split("").forEach(function(letter) {
                    test3[letter] = letter;
                }), "abcdefghijklmnopqrst" === Object.keys(Object.assign({}, test3)).join("");
            } catch (e) {
                // We don't expect any of the above to throw, but better to be safe.
                return !1;
            }
        }
        /* eslint-disable no-unused-vars */
        var hasOwnProperty = Object.prototype.hasOwnProperty, propIsEnumerable = Object.prototype.propertyIsEnumerable;
        module.exports = shouldUseNative() ? Object.assign : function(target, source) {
            for (var from, symbols, to = toObject(target), s = 1; s < arguments.length; s++) {
                from = Object(arguments[s]);
                for (var key in from) hasOwnProperty.call(from, key) && (to[key] = from[key]);
                if (Object.getOwnPropertySymbols) {
                    symbols = Object.getOwnPropertySymbols(from);
                    for (var i = 0; i < symbols.length; i++) propIsEnumerable.call(from, symbols[i]) && (to[symbols[i]] = from[symbols[i]]);
                }
            }
            return to;
        };
    }, /* 14 */
    /***/
    function(module, exports) {
        "use strict";
        /**
	 * Like el.hasAttribute(attr) but designed for use within a skate attribute
	 * change handler where you only have access to change.oldValue.
	 */
        function computeBooleanValue(attrValue) {
            return null !== attrValue;
        }
        function setBooleanAttribute(el, attr, newValue) {
            newValue ? el.setAttribute(attr, "") : el.removeAttribute(attr);
        }
        function computeEnumValue(enumOptions, value) {
            var matchesEnumValue = function(enumValue) {
                return enumValue.toLowerCase() === value.toLowerCase();
            }, isMissing = null === value || void 0 === value, isInvalid = !isMissing && !enumOptions.values.filter(matchesEnumValue).length;
            return isMissing ? enumOptions.hasOwnProperty("missingDefault") ? enumOptions.missingDefault : null : isInvalid ? enumOptions.hasOwnProperty("invalidDefault") ? enumOptions.invalidDefault : enumOptions.hasOwnProperty("missingDefault") ? enumOptions.missingDefault : null : enumOptions.values.length ? enumOptions.values.filter(matchesEnumValue)[0] : null;
        }
        function setEnumAttribute(el, enumOptions, newValue) {
            el.setAttribute(enumOptions.attribute, newValue);
        }
        Object.defineProperty(exports, "__esModule", {
            value: !0
        }), /**
	 * Helper functions useful for implementing reflected boolean and enumerated
	 * attributes and properties.
	 *
	 * @see https://html.spec.whatwg.org/multipage/infrastructure.html#reflecting-content-attributes-in-idl-attributes
	 * @see https://html.spec.whatwg.org/multipage/infrastructure.html#boolean-attribute
	 * @see https://html.spec.whatwg.org/multipage/infrastructure.html#enumerated-attribute
	 */
        exports.computeBooleanValue = computeBooleanValue, exports.setBooleanAttribute = setBooleanAttribute, 
        exports.computeEnumValue = computeEnumValue, exports.setEnumAttribute = setEnumAttribute;
    }, /* 15 */
    /***/
    function(module, exports) {
        // Source: http://jsfiddle.net/vWx8V/
        // http://stackoverflow.com/questions/5603195/full-list-of-javascript-keycodes
        /**
	 * Conenience method returns corresponding value for given keyName or keyCode.
	 *
	 * @param {Mixed} keyCode {Number} or keyName {String}
	 * @return {Mixed}
	 * @api public
	 */
        exports = module.exports = function(searchInput) {
            // Keyboard Events
            if (searchInput && "object" == typeof searchInput) {
                var hasKeyCode = searchInput.which || searchInput.keyCode || searchInput.charCode;
                hasKeyCode && (searchInput = hasKeyCode);
            }
            // Numbers
            if ("number" == typeof searchInput) return names[searchInput];
            // Everything else (cast to string)
            var search = String(searchInput), foundNamedKey = codes[search.toLowerCase()];
            if (foundNamedKey) return foundNamedKey;
            // check aliases
            var foundNamedKey = aliases[search.toLowerCase()];
            // weird character?
            return foundNamedKey ? foundNamedKey : 1 === search.length ? search.charCodeAt(0) : void 0;
        };
        /**
	 * Get by name
	 *
	 *   exports.code['enter'] // => 13
	 */
        var codes = exports.code = exports.codes = {
            backspace: 8,
            tab: 9,
            enter: 13,
            shift: 16,
            ctrl: 17,
            alt: 18,
            "pause/break": 19,
            "caps lock": 20,
            esc: 27,
            space: 32,
            "page up": 33,
            "page down": 34,
            end: 35,
            home: 36,
            left: 37,
            up: 38,
            right: 39,
            down: 40,
            insert: 45,
            "delete": 46,
            command: 91,
            "left command": 91,
            "right command": 93,
            "numpad *": 106,
            "numpad +": 107,
            "numpad -": 109,
            "numpad .": 110,
            "numpad /": 111,
            "num lock": 144,
            "scroll lock": 145,
            "my computer": 182,
            "my calculator": 183,
            ";": 186,
            "=": 187,
            ",": 188,
            "-": 189,
            ".": 190,
            "/": 191,
            "`": 192,
            "[": 219,
            "\\": 220,
            "]": 221,
            "'": 222
        }, aliases = exports.aliases = {
            windows: 91,
            "⇧": 16,
            "⌥": 18,
            "⌃": 17,
            "⌘": 91,
            ctl: 17,
            control: 17,
            option: 18,
            pause: 19,
            "break": 19,
            caps: 20,
            "return": 13,
            escape: 27,
            spc: 32,
            pgup: 33,
            pgdn: 34,
            ins: 45,
            del: 46,
            cmd: 91
        };
        /*!
	 * Programatically add the following
	 */
        // lower case chars
        for (i = 97; i < 123; i++) codes[String.fromCharCode(i)] = i - 32;
        // numbers
        for (var i = 48; i < 58; i++) codes[i - 48] = i;
        // function keys
        for (i = 1; i < 13; i++) codes["f" + i] = i + 111;
        // numpad keys
        for (i = 0; i < 10; i++) codes["numpad " + i] = i + 96;
        /**
	 * Get by code
	 *
	 *   exports.name[13] // => 'Enter'
	 */
        var names = exports.names = exports.title = {};
        // title for backward compat
        // Create reverse mapping
        for (i in codes) names[codes[i]] = i;
        // Add aliases
        for (var alias in aliases) codes[alias] = aliases[alias];
    }, /* 16 */
    /***/
    function(module, exports, __webpack_require__) {
        "use strict";
        function _interopRequireDefault(obj) {
            return obj && obj.__esModule ? obj : {
                "default": obj
            };
        }
        function keyInvalidError(key) {
            return new KeyInvalidError('Given key "' + key + '" is not valid');
        }
        Object.defineProperty(exports, "__esModule", {
            value: !0
        }), exports.CallbackInvalidError = exports.KeyInvalidError = void 0;
        var _classCallCheck2 = __webpack_require__(17), _classCallCheck3 = _interopRequireDefault(_classCallCheck2), _createClass2 = __webpack_require__(18), _createClass3 = _interopRequireDefault(_createClass2), _keycode = __webpack_require__(15), _keycode2 = _interopRequireDefault(_keycode), _createError = __webpack_require__(37), _createError2 = _interopRequireDefault(_createError), KeyInvalidError = (0, 
        _createError2["default"])("KeyInvalidError"), CallbackInvalidError = (0, _createError2["default"])("CallbackInvalidError"), KeyPressHandler = function() {
            /**
	  * Adds a new keypress handler
	  *
	  * @constructor
	  * @param {String} key A named key. Case insensitive.
	  * @param {Function} callback A callback function to invoke if the given key was activated.
	  *                            The callback is passed the event object.
	  * @param {Node} [elem]  The element to listen for the key activation.
	  *                       Defaults to document if none given.
	  */
            function KeyPressHandler(key, callback, elem) {
                var _this = this;
                (0, _classCallCheck3["default"])(this, KeyPressHandler), this.keyListeners = {};
                var code = (0, _keycode2["default"])(key);
                if ("undefined" == typeof code) throw keyInvalidError(key);
                if ("function" != typeof callback) throw new CallbackInvalidError();
                this.keyListeners[code] = callback, this.elem = elem || document, this.listener = function(e) {
                    _this.keyListeners[e.keyCode] && _this.keyListeners[e.keyCode](e);
                }, this.elem.addEventListener("keydown", this.listener);
            }
            /**
	  * Adds or replaces a key that is listened for.
	  *
	  * @param {String} key A named key. Case insensitive. Replaces any previous listened key.
	  * @param {Function} callback The callback function to invoke.
	  */
            return (0, _createClass3["default"])(KeyPressHandler, [ {
                key: "add",
                value: function(key, callback) {
                    var code = (0, _keycode2["default"])(key);
                    if ("undefined" == typeof code) throw keyInvalidError(key);
                    if ("function" != typeof callback) throw new CallbackInvalidError();
                    this.keyListeners[code] = callback;
                }
            }, {
                key: "destroy",
                value: function(key) {
                    key ? delete this.keyListeners[(0, _keycode2["default"])(key)] : (// Don't change this to {}, otherwise a destroyed KeyPressHandler can be "recycled"
                    // without having an event listener attached
                    this.keyListeners = void 0, this.elem.removeEventListener("keydown", this.listener));
                }
            } ]), KeyPressHandler;
        }();
        exports["default"] = KeyPressHandler, exports.KeyInvalidError = KeyInvalidError, 
        exports.CallbackInvalidError = CallbackInvalidError;
    }, /* 17 */
    /***/
    function(module, exports) {
        "use strict";
        exports.__esModule = !0, exports["default"] = function(instance, Constructor) {
            if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
        };
    }, /* 18 */
    /***/
    function(module, exports, __webpack_require__) {
        "use strict";
        function _interopRequireDefault(obj) {
            return obj && obj.__esModule ? obj : {
                "default": obj
            };
        }
        exports.__esModule = !0;
        var _defineProperty = __webpack_require__(19), _defineProperty2 = _interopRequireDefault(_defineProperty);
        exports["default"] = function() {
            function defineProperties(target, props) {
                for (var i = 0; i < props.length; i++) {
                    var descriptor = props[i];
                    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, 
                    "value" in descriptor && (descriptor.writable = !0), (0, _defineProperty2["default"])(target, descriptor.key, descriptor);
                }
            }
            return function(Constructor, protoProps, staticProps) {
                return protoProps && defineProperties(Constructor.prototype, protoProps), staticProps && defineProperties(Constructor, staticProps), 
                Constructor;
            };
        }();
    }, /* 19 */
    /***/
    function(module, exports, __webpack_require__) {
        module.exports = {
            "default": __webpack_require__(20),
            __esModule: !0
        };
    }, /* 20 */
    /***/
    function(module, exports, __webpack_require__) {
        __webpack_require__(21);
        var $Object = __webpack_require__(24).Object;
        module.exports = function(it, key, desc) {
            return $Object.defineProperty(it, key, desc);
        };
    }, /* 21 */
    /***/
    function(module, exports, __webpack_require__) {
        var $export = __webpack_require__(22);
        // 19.1.2.4 / 15.2.3.6 Object.defineProperty(O, P, Attributes)
        $export($export.S + $export.F * !__webpack_require__(32), "Object", {
            defineProperty: __webpack_require__(28).f
        });
    }, /* 22 */
    /***/
    function(module, exports, __webpack_require__) {
        var global = __webpack_require__(23), core = __webpack_require__(24), ctx = __webpack_require__(25), hide = __webpack_require__(27), PROTOTYPE = "prototype", $export = function(type, name, source) {
            var key, own, out, IS_FORCED = type & $export.F, IS_GLOBAL = type & $export.G, IS_STATIC = type & $export.S, IS_PROTO = type & $export.P, IS_BIND = type & $export.B, IS_WRAP = type & $export.W, exports = IS_GLOBAL ? core : core[name] || (core[name] = {}), expProto = exports[PROTOTYPE], target = IS_GLOBAL ? global : IS_STATIC ? global[name] : (global[name] || {})[PROTOTYPE];
            IS_GLOBAL && (source = name);
            for (key in source) // contains in native
            own = !IS_FORCED && target && void 0 !== target[key], own && key in exports || (// export native or passed
            out = own ? target[key] : source[key], // prevent global pollution for namespaces
            exports[key] = IS_GLOBAL && "function" != typeof target[key] ? source[key] : IS_BIND && own ? ctx(out, global) : IS_WRAP && target[key] == out ? function(C) {
                var F = function(a, b, c) {
                    if (this instanceof C) {
                        switch (arguments.length) {
                          case 0:
                            return new C();

                          case 1:
                            return new C(a);

                          case 2:
                            return new C(a, b);
                        }
                        return new C(a, b, c);
                    }
                    return C.apply(this, arguments);
                };
                return F[PROTOTYPE] = C[PROTOTYPE], F;
            }(out) : IS_PROTO && "function" == typeof out ? ctx(Function.call, out) : out, // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
            IS_PROTO && ((exports.virtual || (exports.virtual = {}))[key] = out, // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
            type & $export.R && expProto && !expProto[key] && hide(expProto, key, out)));
        };
        // type bitmap
        $export.F = 1, // forced
        $export.G = 2, // global
        $export.S = 4, // static
        $export.P = 8, // proto
        $export.B = 16, // bind
        $export.W = 32, // wrap
        $export.U = 64, // safe
        $export.R = 128, // real proto method for `library` 
        module.exports = $export;
    }, /* 23 */
    /***/
    function(module, exports) {
        // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
        var global = module.exports = "undefined" != typeof window && window.Math == Math ? window : "undefined" != typeof self && self.Math == Math ? self : Function("return this")();
        "number" == typeof __g && (__g = global);
    }, /* 24 */
    /***/
    function(module, exports) {
        var core = module.exports = {
            version: "2.4.0"
        };
        "number" == typeof __e && (__e = core);
    }, /* 25 */
    /***/
    function(module, exports, __webpack_require__) {
        // optional / simple context binding
        var aFunction = __webpack_require__(26);
        module.exports = function(fn, that, length) {
            if (aFunction(fn), void 0 === that) return fn;
            switch (length) {
              case 1:
                return function(a) {
                    return fn.call(that, a);
                };

              case 2:
                return function(a, b) {
                    return fn.call(that, a, b);
                };

              case 3:
                return function(a, b, c) {
                    return fn.call(that, a, b, c);
                };
            }
            return function() {
                return fn.apply(that, arguments);
            };
        };
    }, /* 26 */
    /***/
    function(module, exports) {
        module.exports = function(it) {
            if ("function" != typeof it) throw TypeError(it + " is not a function!");
            return it;
        };
    }, /* 27 */
    /***/
    function(module, exports, __webpack_require__) {
        var dP = __webpack_require__(28), createDesc = __webpack_require__(36);
        module.exports = __webpack_require__(32) ? function(object, key, value) {
            return dP.f(object, key, createDesc(1, value));
        } : function(object, key, value) {
            return object[key] = value, object;
        };
    }, /* 28 */
    /***/
    function(module, exports, __webpack_require__) {
        var anObject = __webpack_require__(29), IE8_DOM_DEFINE = __webpack_require__(31), toPrimitive = __webpack_require__(35), dP = Object.defineProperty;
        exports.f = __webpack_require__(32) ? Object.defineProperty : function(O, P, Attributes) {
            if (anObject(O), P = toPrimitive(P, !0), anObject(Attributes), IE8_DOM_DEFINE) try {
                return dP(O, P, Attributes);
            } catch (e) {}
            if ("get" in Attributes || "set" in Attributes) throw TypeError("Accessors not supported!");
            return "value" in Attributes && (O[P] = Attributes.value), O;
        };
    }, /* 29 */
    /***/
    function(module, exports, __webpack_require__) {
        var isObject = __webpack_require__(30);
        module.exports = function(it) {
            if (!isObject(it)) throw TypeError(it + " is not an object!");
            return it;
        };
    }, /* 30 */
    /***/
    function(module, exports) {
        module.exports = function(it) {
            return "object" == typeof it ? null !== it : "function" == typeof it;
        };
    }, /* 31 */
    /***/
    function(module, exports, __webpack_require__) {
        module.exports = !__webpack_require__(32) && !__webpack_require__(33)(function() {
            return 7 != Object.defineProperty(__webpack_require__(34)("div"), "a", {
                get: function() {
                    return 7;
                }
            }).a;
        });
    }, /* 32 */
    /***/
    function(module, exports, __webpack_require__) {
        // Thank's IE8 for his funny defineProperty
        module.exports = !__webpack_require__(33)(function() {
            return 7 != Object.defineProperty({}, "a", {
                get: function() {
                    return 7;
                }
            }).a;
        });
    }, /* 33 */
    /***/
    function(module, exports) {
        module.exports = function(exec) {
            try {
                return !!exec();
            } catch (e) {
                return !0;
            }
        };
    }, /* 34 */
    /***/
    function(module, exports, __webpack_require__) {
        var isObject = __webpack_require__(30), document = __webpack_require__(23).document, is = isObject(document) && isObject(document.createElement);
        module.exports = function(it) {
            return is ? document.createElement(it) : {};
        };
    }, /* 35 */
    /***/
    function(module, exports, __webpack_require__) {
        // 7.1.1 ToPrimitive(input [, PreferredType])
        var isObject = __webpack_require__(30);
        // instead of the ES6 spec version, we didn't implement @@toPrimitive case
        // and the second argument - flag - preferred type is a string
        module.exports = function(it, S) {
            if (!isObject(it)) return it;
            var fn, val;
            if (S && "function" == typeof (fn = it.toString) && !isObject(val = fn.call(it))) return val;
            if ("function" == typeof (fn = it.valueOf) && !isObject(val = fn.call(it))) return val;
            if (!S && "function" == typeof (fn = it.toString) && !isObject(val = fn.call(it))) return val;
            throw TypeError("Can't convert object to primitive value");
        };
    }, /* 36 */
    /***/
    function(module, exports) {
        module.exports = function(bitmap, value) {
            return {
                enumerable: !(1 & bitmap),
                configurable: !(2 & bitmap),
                writable: !(4 & bitmap),
                value: value
            };
        };
    }, /* 37 */
    /***/
    function(module, exports, __webpack_require__) {
        var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_RESULT__;
        //     create-error.js 0.3.1
        //     (c) 2013 Tim Griesser
        //     This source may be freely distributed under the MIT license.
        !function(factory) {
            "use strict";
            // A simple utility for subclassing the "Error"
            // object in multiple environments, while maintaining
            // relevant stack traces, messages, and prototypes.
            factory(function() {
                // Just a few helpers to clean up the function above
                // https://github.com/petkaantonov/bluebird/wiki/Optimization-killers
                function getName(args) {
                    return 0 === args.length ? "" : isError(args[0]) ? args[1] || "" : args[0];
                }
                function getTarget(args) {
                    return 0 === args.length ? Error : isError(args[0]) ? args[0] : Error;
                }
                function getProps(args) {
                    return 0 === args.length ? null : isError(args[0]) ? args[2] : args[1];
                }
                function inheritedKeys(obj) {
                    var ret = [];
                    for (var key in obj) ret.push(key);
                    return ret;
                }
                // Right now we're just assuming that a function in the first argument is an error.
                function isError(obj) {
                    return "function" == typeof obj;
                }
                // We don't need the full underscore check here, since it should either be
                // an object-literal, or nothing at all.
                function isObject(obj) {
                    return obj && "object" == typeof obj && "[object Object]" === toString.call(obj);
                }
                // Used to attach attributes to the error object in the constructor.
                function attachProps(context, target) {
                    if (isObject(target)) for (var keys = inheritedKeys(target), i = 0, l = keys.length; i < l; ++i) context[keys[i]] = clone(target[keys[i]]);
                }
                // Don't need the full-out "clone" mechanism here, since if you're
                // trying to set things other than empty arrays/objects on your
                // sub-classed `Error` object, you're probably doing it wrong.
                function clone(target) {
                    if (null == target || "object" != typeof target) return target;
                    var cloned = target.constructor ? target.constructor() : Object.create(null);
                    for (var attr in target) target.hasOwnProperty(attr) && (cloned[attr] = target[attr]);
                    return cloned;
                }
                var toString = Object.prototype.toString;
                // Creates an new error type with a "name",
                // and any additional properties that should be set
                // on the error instance.
                return function() {
                    function ErrorCtor(message, obj) {
                        attachProps(this, properties), attachProps(this, obj), this.message = message || this.message, 
                        message instanceof Error ? (this.message = message.message, this.stack = message.stack) : Error.captureStackTrace && Error.captureStackTrace(this, this.constructor);
                    }
                    function Err() {
                        this.constructor = ErrorCtor;
                    }
                    for (var args = new Array(arguments.length), i = 0; i < args.length; ++i) args[i] = arguments[i];
                    var name = getName(args), target = getTarget(args), properties = getProps(args);
                    return Err.prototype = target.prototype, ErrorCtor.prototype = new Err(), ErrorCtor.prototype.name = "" + name || "CustomError", 
                    ErrorCtor;
                };
            });
        }(function(createErrorLib) {
            __WEBPACK_AMD_DEFINE_FACTORY__ = createErrorLib, __WEBPACK_AMD_DEFINE_RESULT__ = "function" == typeof __WEBPACK_AMD_DEFINE_FACTORY__ ? __WEBPACK_AMD_DEFINE_FACTORY__.call(exports, __webpack_require__, exports, module) : __WEBPACK_AMD_DEFINE_FACTORY__, 
            !(void 0 !== __WEBPACK_AMD_DEFINE_RESULT__ && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
        });
    } ]);
});